//****************************************************
//***** AKIDUKI RGB LED with CPU controlling *********
//*************************** By Minarai Shokunin ****
//*************************** 2014/10/08         ****
//****************************************************

#include "p24F04KA201.h"
#define LEDS 8
#define BUFSIZE 3*8*LEDS

//_CONFIG1(0x5f24)

unsigned int BitScreen[BUFSIZE];
unsigned int PixelScreenR[LEDS];
unsigned int PixelScreenG[LEDS];
unsigned int PixelScreenB[LEDS];
// ************ prototypes ***************************

// *********************************************
// ************ MAIN ***************************
// *********************************************

int main(void)
{

	// ************ CPU Initialize **********
	CLKDIV = 0;
	OSCTUN = 0x001f;

	PORTA = 0;
	TRISA = 0x0000;	

	// ************ software initialize **********
	cls();

	// ************ MAIN LOOP ********************
	set_rgb(0,0,0,0);	
	set_rgb(1,0,0,0);	
	set_rgb(2,10,0,0);	
	set_rgb(3,0,10,0);	
	set_rgb(4,0,0,10);	
	set_rgb(5,10,0,0);	
	set_rgb(6,0,10,0);	
	set_rgb(7,0,0,10);	

	set_leds();
	while(1) {
	}
}


//**********************************
//*** SETPIXEL ***************
//**********************************
void set_rgb(int x,int r,int g,int b)
{
	int i;
	unsigned int wr,wg,wb;

	//****** sNZXN[ɏ ************
	PixelScreenR[x*8] = r;
	PixelScreenG[x*8] = g;
	PixelScreenB[x*8] = b;
	//****** rbgXN[ɓWJ ************	
	wr = r<<8;
	wg = g<<8;
	wb = b<<8;
 
	for (i=0;i<8;i++) {
		if ((wg & 0x8000)==0) {
			BitScreen[x*24+i] = 0;
		}else{
			BitScreen[x*24+i] = 1;
		}
		wg <<= 1;
		if ((wr & 0x8000)==0) {
			BitScreen[x*24+i+8] = 0;
		}else{
			BitScreen[x*24+i+8] = 1;
		}
		wr <<= 1;
		if ((wb & 0x8000)==0) {
			BitScreen[x*24+i+16] = 0;
		}else{
			BitScreen[x*24+i+16] = 1;
		}
		wb <<= 1;
	}
}


//**********************************
//*** 1ms EFCg  ***************
//**********************************
void wait_ms(int t)
{
	int t0,t1;
	for (t0 = 0; t0<t;t0++) {
		for (t1=0;t1<1000;t1++) {

		}
	}
}


//**********************************
//*** CLS      ***************
//**********************************
void cls(void)
{
	int i,j;

	for (i=0;i<BUFSIZE;i++) {
		BitScreen[i]=0;
	}
	for (i=0;i<LEDS;i++) {
		for (j=0;j<8;j++) {
			PixelScreenR[i*8+j] =0;
			PixelScreenG[i*8+j] =0;
			PixelScreenB[i*8+j] =0;
		}
	}

}

//**********************************
//*** LED@      ***************
//**********************************

void set_leds(void)
{
	int i;
	int t;

	PORTA = 0x0;
	for (t=0;t<20000;t++) {
	}
	
	for (i=0;i<BUFSIZE;i++) {
		if (BitScreen[i] ==0) {
			PORTA = 0xffff;
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			PORTA = 0x0000;
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
		}else{
			PORTA = 0xffff;
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			PORTA = 0x0000;
		}
	}
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
			asm("NOP");
	PORTA = 0x0ffff;
}